#### Beyond Linux® From Scratch (System V Edition) - Version 12.3

### Chapter 24. Graphical Environments

- Prev

  Xorg-Server-21.1.16

- Next

  twm-1.0.12

- Up
- Home

# Xorg Input Drivers

## Introduction to Xorg Input Drivers

The Xorg Input Drivers page contains the instructions for building Xorg input drivers that are necessary in order for Xorg Server to respond user inputs.

### Xorg Input Drivers

- libevdev-1.13.3

- Xorg Evdev Driver-2.11.0

- libinput-1.27.1

- xorg-libinput-1.5.0

- Xorg Synaptics Driver-1.10.0

- Xorg Wacom Driver-1.2.3

## libevdev 1.13.3

### Introduction to libevdev

The libevdev package contains common functions for Xorg input drivers.

This package is known to build and work properly using an LFS 12.3 platform.

#### Package Information

- Download (HTTP): https://www.freedesktop.org/software/libevdev/libevdev-1.13.3.tar.xz

- Download MD5 sum: 57ee77b7d4c480747e693779bb92fb84

- Download size: 452 KB

- Estimated disk space required: 6.2 MB (with tests)

- Estimated build time: less than 0.1 SBU (with tests)

#### libevdev Dependencies

##### Optional

Doxygen-1.13.2 and Valgrind-3.24.0 (optional for tests)

### Kernel Configuration

Enable the following options in the kernel configuration and recompile the kernel if necessary:

    Device Drivers --->
      Input device support --->
        -*-   Generic input layer (needed for keyboard, mouse, ...)          [INPUT]
        <*/M>   Event interface                                        [INPUT_EVDEV]

If you want to test this package with full coverage, the following options are needed as well:

    Device Drivers --->
      Input device support --->
        -*- Generic input layer (needed for keyboard, mouse, ...)            [INPUT]
        [*]   Miscellaneous devices --->                                [INPUT_MISC]
          <*/M>   User level driver support                           [INPUT_UINPUT]

If you build this as a module, it needs to be inserted before the test suite runs.

### Installation of libevdev

Install libevdev by running the following commands:

    mkdir build &&
    cd    build &&

    meson setup ..                  \
          --prefix=$XORG_PREFIX     \
          --buildtype=release       \
          -D documentation=disabled &&
    ninja

The regression tests can be run as the `root` user with ninja test, in a graphical session. You need to have enabled the CONFIG_INPUT_UINPUT setting in the kernel for full test coverage. If it is enabled as a module, the module is named uinput and needs to be loaded before running the tests. Note that on some systems, the tests may cause a hard lockup and require a reboot. On laptops, the system will go into Sleep and need to be woken up to finish the test suites.

Now, as the `root` user:

    ninja install

### Contents

Installed Xorg Programs: libevdev-tweak-device, mouse-dpi-tool, and touchpad-edge-detector
Installed Xorg Library: libevdev.so
Installed Xorg Directory: $XORG_PREFIX/include/libevdev-1.0

#### Short Descriptions

libevdev-tweak-device | is a tool to change some kernel device properties
mouse-dpi-tool | is a tool to estimate the resolution of a mouse
touchpad-edge-detector | touchpad-edge-detector is a tool that reads the touchpad events from the kernel and calculates the minimum and maximum for the x and y coordinates, respectively
`libevdev.so` | is a library of Xorg driver input functions

## Xorg Evdev Driver-2.11.0

### Introduction to Xorg Evdev Driver

The Xorg Evdev Driver package contains a Generic Linux input driver for the Xorg X server. It handles keyboard, mouse, touchpads and wacom devices, though for touchpad and wacom advanced handling, additional drivers are required.

This package is known to build and work properly using an LFS 12.3 platform.

#### Package Information

- Download (HTTP): https://www.x.org/pub/individual/driver/xf86-input-evdev-2.11.0.tar.xz

- Download MD5 sum: faa89be0ef86aebd6fd0a03eed23839c

- Download size: 344 KB

- Estimated disk space required: 3.7 MB

- Estimated build time: less than 0.1 SBU

#### Xorg Evdev Driver Dependencies

##### Required

libevdev-1.13.3, mtdev-1.1.7, and Xorg-Server-21.1.16

### Installation of Xorg Evdev Driver

Install Xorg Evdev Driver by running the following commands:

    ./configure $XORG_CONFIG &&
    make

This package does not come with a test suite.

Now, as the `root` user:

    make install

### Contents

Installed Xorg Driver: evdev_drv.so

#### Short Descriptions

`evdev_drv.so` | is an Xorg input driver for Linux generic event devices

## libinput-1.27.1

### Introduction to Libinput

libinput is a library that handles input devices for display servers and other applications that need to directly deal with input devices.

This package is known to build and work properly using an LFS 12.3 platform.

#### Package Information

- Download (HTTP): https://gitlab.freedesktop.org/libinput/libinput/-/archive/1.27.1/libinput-1.27.1.tar.gz

- Download MD5 sum: 3b311d8953f8717f711a78b60087997e

- Download size: 1.1 MB

- Estimated disk space required: 14 MB (add 35 MB for documentation)

- Estimated build time: 0.1 SBU (add 0.1 SBU for documentation and 0.1 SBU for minor tests)

#### libinput Dependencies

##### Required

libevdev-1.13.3 and mtdev-1.1.7

##### Optional

Valgrind-3.24.0 (to run the tests), GTK-3.24.48 (to build the GUI event viewer), libunwind-1.8.1 (required for tests), libwacom-2.14.0, Doxygen-1.13.2, Graphviz-12.2.1, recommonmark-0.7.1, and sphinx_rtd_theme-3.0.2 (required to build documentation), pyparsing-3.2.1 (for one non-root test), and pytest-8.3.4 (for another non-root test)

### Kernel Configuration for Running the Libinput Test Suite

Although libinput works with the same kernel configuration used by libevdev-1.13.3, its standard and more expansive test suite requires the presence of `/dev/uinput` (as well as both Valgrind-3.24.0 and libunwind-1.8.1).

If you wish to run the standard test suite, enable the following option in the kernel configuration and recompile the kernel if necessary:

    Device Drivers --->
      Input device support --->
        -*- Generic input layer (needed for keyboard, mouse, ...)            [INPUT]
        [*]   Miscellaneous devices --->                                [INPUT_MISC]
          <*/M>   User level driver support                           [INPUT_UINPUT]

If you build this as a module, it needs to be inserted before the test suite runs.

### Installation of Libinput

Install libinput by running the following commands:

    mkdir build &&
    cd    build &&

    meson setup ..                  \
          --prefix=$XORG_PREFIX     \
          --buildtype=release       \
          -D debug-gui=false        \
          -D tests=false            \
          -D libwacom=false         \
          -D udev-dir=/usr/lib/udev &&
    ninja

### Note

If you want to run the standard test suite, remove -D tests from the meson command above. Please read “Kernel Configuration for Running the Libinput Test Suite” (above).

If you have decided the run the standard test suite, you can run the tests as the root user by executing: ninja test. There are over 30 tests and all should pass if you installed the optional dependencies. However, you can run 6 minor tests as the regular user by running the same command, although you will not need to remove the -D tests parameter. The test measurements are based off of those tests alone.

Now, as the `root` user:

    ninja install

If you have passed `-D documentation=true` to meson, you can install the generated documentation by running the following commands as the `root` user:

    install -v -dm755      /usr/share/doc/libinput-1.27.1/html &&
    cp -rv Documentation/* /usr/share/doc/libinput-1.27.1/html

### Command Explanations

`--buildtype=release`: Specify a buildtype suitable for stable releases of the package, as the default may produce unoptimized binaries.

`-D debug-gui=false`: This switch disables creation of a visual debug helper for libinput. Remove if you want it, and you have GTK-3.24.48 installed.

`-D tests=false`: This switch disables compilation of the standard test suite. Even with the tests defined as false, you can still run the first six minor tests as a regular user, but one will be skipped if pyparsing-3.2.1 is not installed, and another one if pytest-8.3.4 is not installed.

`-D libwacom=false`: Remove this option if you have libwacom-2.14.0 installed, or if you are installing GNOME.

`-D udev-dir=/usr/lib/udev`: In case that the value of `XORG_PREFIX` is not set to `/usr`, this option prevents the package from installing Udev rules and helpers into `$XORG_PREFIX/lib/udev` which is not searched by Udev daemon. This option is not needed for systems with `XORG_PREFIX` set to `/usr`, but does no harm.

`-D documentation=true`: This switch enables generation of the documentation. Add it if you want to generate the documentation. You must have Doxygen-1.13.2 and Graphviz-12.2.1 installed.

### Contents

Installed Programs: libinput
Installed Libraries: libinput.so
Installed Directories: /etc/libinput, $XORG_PREFIX/libexec/libinput, $XORG_PREFIX/share/libinput, and (optionally) $XORG_PREFIX/share/doc/libinput-1.27.1

### Short Descriptions

libinput | is a set of tools to interface with the libinput library
`libinput.so` | contains API functions for handling input devices

## Xorg Libinput Driver-1.5.0

### Introduction to Xorg Libinput Driver

The X.Org Libinput Driver is a thin wrapper around libinput and allows for libinput to be used for input devices in X. This driver can be used as drop-in replacement for evdev and synaptics.

This package is known to build and work properly using an LFS 12.3 platform.

#### Package Information

- Download (HTTP): https://www.x.org/pub/individual/driver/xf86-input-libinput-1.5.0.tar.xz

- Download MD5 sum: f8d0fb6987d843e688d597c2b66ec824

- Download size: 324 KB

- Estimated disk space required: 3.9 MB (with tests)

- Estimated build time: less than 0.1 SBU (with tests)

#### Xorg Libinput Driver Dependencies

##### Required

libinput-1.27.1 and Xorg-Server-21.1.16

### Installation of Xorg Libinput Driver

Install Xorg Libinput Driver by running the following commands:

    ./configure $XORG_CONFIG &&
    make

To test the results, issue make check.

Now, as the `root` user:

    make install

### Contents

Installed Xorg Driver: libinput_drv.so

#### Short Descriptions

`libinput_drv.so` | is an Xorg input driver for mouse, keyboard, touchpad, touchscreen, and tablet devices

## Xorg Synaptics Driver-1.10.0

### Introduction to Xorg Synaptics Driver

The Xorg Synaptics Driver package contains the X.Org Input Driver, support programs and SDK for Synaptics touchpads. Even though the evdev driver can handle touchpads very well, this driver is required if you want to use advanced features like multi tapping, scrolling with touchpad, turning the touchpad off while typing, etc.

This package is known to build and work properly using an LFS 12.3 platform.

#### Package Information

- Download (HTTP): https://www.x.org/pub/individual/driver/xf86-input-synaptics-1.10.0.tar.xz

- Download MD5 sum: 017383c13a0d0f4cb320be477ab25513

- Download size: 424 KB

- Estimated disk space required: 5.3 MB

- Estimated build time: less than 0.1 SBU

#### Xorg Synaptics Driver Dependencies

##### Required

libevdev-1.13.3 and Xorg-Server-21.1.16

### Installation of Xorg Synaptics Driver

Install Xorg Synaptics Driver by running the following commands:

    ./configure $XORG_CONFIG &&
    make

This package does not come with a test suite.

Now, as the `root` user:

    make install

### Contents

Installed Programs: synclient and syndaemon
Installed Xorg Driver: synaptics_drv.so

#### Short Descriptions

synclient | is a command line utility used to query and modify Synaptics driver options
syndaemon | is a program that monitors keyboard activity and disables the touchpad when the keyboard is being used
`synaptics_drv.so` | is an Xorg input driver for touchpads

## Xorg Wacom Driver-1.2.3

### Introduction to Xorg Wacom Driver

The Xorg Wacom Driver package contains the X.Org X11 driver and SDK for Wacom and Wacom-like tablets. It is not required to use a Wacom tablet, the xf86-input-evdev driver can handle these devices without problems.

This package is known to build and work properly using an LFS 12.3 platform.

#### Package Information

- Download (HTTP): https://github.com/linuxwacom/xf86-input-wacom/releases/download/xf86-input-wacom-1.2.3/xf86-input-wacom-1.2.3.tar.bz2

- Download MD5 sum: ef8a6cc34623db6c3482508374863d51

- Download size: 660 KB

- Estimated disk space required: 8.1 MB (with tests)

- Estimated build time: 0.1 SBU (with tests)

#### Xorg Wacom Drivers Dependencies

##### Required

Xorg-Server-21.1.16

##### Optional

Doxygen-1.13.2 and Graphviz-12.2.1

### Kernel Configuration

To use a Wacom tablet with USB interface, enable the following options in your kernel configuration and recompile. Note that other configuration options could be required for tablet with a serial or bluetooth interface:

    Device Drivers --->
      [*] HID bus support --->                                         [HID_SUPPORT]
        {*/M} HID bus core support                                             [HID]
          Special HID drivers --->
          <*/M>   Wacom Intuos/Graphire tablet support (USB)             [HID_WACOM]
        USB HID support --->
          <*/M> USB HID transport layer                                    [USB_HID]
      [*] USB support --->                                             [USB_SUPPORT]
        <*/M> Support for Host-side USB                                        [USB]

### Installation of Xorg Wacom Driver

Install Xorg Wacom Driver by running the following commands:

    ./configure $XORG_CONFIG --with-systemd-unit-dir=no &&
    make

To test the results, issue: make check.

Now, as the `root` user:

    make install

### Contents

Installed Programs: isdv4-serial-debugger, isdv4-serial-inputattach, and xsetwacom
Installed Xorg Driver: wacom_drv.so

#### Short Descriptions

xsetwacom | is a commandline utility used to query and modify wacom driver settings
`wacom_drv.so` | is an Xorg input driver for Wacom devices

- Prev

  Xorg-Server-21.1.16

- Next

  twm-1.0.12

- Up
- Home